// ePDFView - A lightweight PDF Viewer.
// Copyright (C) 2006 Emma's Software.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#if !defined (__DOCUMENT_PAGE_H__)
#define __DOCUMENT_PAGE_H__

namespace ePDFView
{
    ///
    /// @class DocumentPage
    /// @brief A single document's page.
    ///
    /// Contains the rendered image of a single document's page.
    ///
    class DocumentPage
    {
        public:
            DocumentPage (void);
            ~DocumentPage (void);
            
            guchar *getData (void);
            gint getHeight (void);
            gint getRowStride (void);
            gint getWidth (void);
            gboolean newPage (gint width, gint height);

        private:
            guchar *m_Data;
            gint m_Height;
            gint m_Width;
    };
}

#endif // !__DOCUMENT_PAGE_H__
