// ePDFView - Dumb Test Main View.
// Copyright (C) 2006 Emma's Software.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#if !defined(__DUMB_MAIN_VIEW_H__)
#define __DUMB_MAIN_VIEW_H__

namespace ePDFView 
{
    class DumbMainView: public IMainView
    {
        public:
            // Interface methods.
            DumbMainView (MainPter *pter);
            ~DumbMainView ();

            gchar *openFileDialog (void);
            gchar *promptPasswordDialog (void);
            void sensitiveGoToFirstPage (gboolean sensitive);
            void sensitiveGoToLastPage (gboolean sensitive);
            void sensitiveGoToNextPage (gboolean sensitive);
            void sensitiveGoToPage (gboolean sensitive);
            void sensitiveGoToPreviousPage (gboolean sensitive);
            void sensitiveReload (gboolean sensitive);
            void sensitiveRotateLeft (gboolean sensitive);
            void sensitiveRotateRight (gboolean sensitive);
            void sensitiveZoomIn (gboolean sensitive);
            void sensitiveZoomOut (gboolean sensitive);
            void sensitiveZoomFit (gboolean sensitive);
            void sensitiveZoomWidth (gboolean sensitive);
            const gchar *getGoToPageText (void);
            void getPageViewSize (gint *width, gint *height);
            void setTotalPages (gint pages);
            void setGoToPageText (const char *text);
            void setTitle (const gchar *title);
            void setOutline (DocumentOutline *outline);
            void show (void);
            void showErrorMessage (const gchar *title, const gchar *body);
            void showPage (DocumentPage *page);
            void showSidebar (gboolean show);

            // Methods for test purposes.
            gint countTimesShownPasswordPrompt (void);
            gint getCurrentPage (void);
            DocumentOutline *getOutline (void);
            const gchar *getTitle (void);
            gint getTotalPages (void);
            gboolean hasImagePageView (void);
            gboolean isShown (void);
            gboolean isSensitiveGoToFirstPage (void);
            gboolean isSensitiveGoToLastPage (void);
            gboolean isSensitiveGoToNextPage (void);
            gboolean isSensitiveGoToPage (void);
            gboolean isSensitiveGoToPreviousPage (void);
            gboolean isSensitiveReload (void);
            gboolean isSensitiveRotateLeft (void);
            gboolean isSensitiveRotateRight (void);
            gboolean isSensitiveZoomIn (void);        
            gboolean isSensitiveZoomOut (void);
            gboolean isSensitiveZoomFit (void);
            gboolean isSensitiveZoomWidth (void);
            gboolean isShownSidebar (void);
            void setOpenFileName (const gchar *fileName);
            void setPassword (const gchar *password);
            gboolean shownError (void);

        protected:
            gint m_CurrentPage;
            DocumentPage *m_DocumentPage;
            gchar *m_GoToPageText;
            gchar *m_OpenFileName;
            DocumentOutline *m_Outline;
            gchar *m_Password;
            gboolean m_SensitiveGoToFirstPage;
            gboolean m_SensitiveGoToLastPage;
            gboolean m_SensitiveGoToNextPage;
            gboolean m_SensitiveGoToPage;
            gboolean m_SensitiveGoToPreviousPage;
            gboolean m_SensitiveReload;
            gboolean m_SensitiveRotateLeft;
            gboolean m_SensitiveRotateRight;
            gboolean m_SensitiveZoomIn;
            gboolean m_SensitiveZoomOut;
            gboolean m_SensitiveZoomFit;
            gboolean m_SensitiveZoomWidth;
            gboolean m_Shown;
            gboolean m_ShownError;
            gboolean m_ShownSidebar;
            gint m_TimesShownPassword;
            gchar *m_Title;
            gint m_TotalPages;
    };
}

#endif // !__DUMB_MAIN_VIEW_H__
